BEGIN;
SELECT _v.register_patch('exchange-0008', NULL, NULL);
SET search_path TO exchange;
CREATE FUNCTION alter_table_aml_history8()
RETURNS VOID
LANGUAGE plpgsql
AS $$
BEGIN
  EXECUTE FORMAT (
    'ALTER TABLE aml_history'
    ' ADD COLUMN kyc_attributes_hash BYTEA CHECK(LENGTH(kyc_attributes_hash)=64)'
    '   DEFAULT NULL'
    ',ADD COLUMN kyc_attributes_serial_id INT8'
    '   DEFAULT NULL'
    ';'
  );
  PERFORM comment_partitioned_column(
     'Hash of the new attributes inserted by the AML officer.'
    ,'kyc_attributes_hash'
    ,'aml_history'
    ,NULL
  );
  PERFORM comment_partitioned_column(
     'Attributes inserted by the AML officer.'
    ,'kyc_attributes_serial_id'
    ,'aml_history'
    ,NULL
  );
END $$;
CREATE FUNCTION foreign_table_aml_history8()
RETURNS void
LANGUAGE plpgsql
AS $$
DECLARE
  table_name TEXT DEFAULT 'aml_history';
BEGIN
  EXECUTE FORMAT (
    'ALTER TABLE ' || table_name ||
    ' ADD CONSTRAINT ' || table_name || '_foreign_key_kyc_attributes'
    ' FOREIGN KEY (kyc_attributes_serial_id)'
    ' REFERENCES kyc_attributes (kyc_attributes_serial_id)');
END
$$;
INSERT INTO exchange_tables
    (name
    ,version
    ,action
    ,partitioned
    ,by_range)
  VALUES
    ('aml_history8'
    ,'exchange-0008'
    ,'alter'
    ,TRUE
    ,FALSE),
    ('aml_history8'
    ,'exchange-0008'
    ,'foreign'
    ,TRUE
    ,FALSE);
COMMIT;
